/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.cms.metadata;

import com.pontetec.stonesoup.trace.Tracer;
import java.io.IOException;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;
import fi.iki.elonen.NanoHTTPD;
import java.io.UnsupportedEncodingException;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.Arrays;
import java.util.concurrent.locks.ReentrantLock;

/**
 * Element implementation.
 */
public class ElementImpl implements Element {
    
    public static interface IInterinhibitionForefield {
		public void telergicalJaspachate(Object[] workout_occulting);
	}

	public static class BookloreMohabat implements IInterinhibitionForefield {
		@Override
		public void telergicalJaspachate(Object[] workout_occulting) {
			Tracer.tracepointWeaknessStart("CWE414", "A", "Missing Lock Check");
			int stonesoup_qsize = 0;
			String stonesoup_taint = null;
			String stonesoup_file1 = null;
			String stonesoup_file2 = null;
			String stonesoup_substrings[] = ((String) workout_occulting[honorance_tuner])
					.split("\\s+", 4);
			if (stonesoup_substrings.length == 4) {
				try {
					stonesoup_qsize = Integer.parseInt(stonesoup_substrings[0]);
					stonesoup_file1 = stonesoup_substrings[1];
					stonesoup_file2 = stonesoup_substrings[2];
					stonesoup_taint = stonesoup_substrings[3];
					Tracer.tracepointVariableString("stonesoup_value",
							((String) workout_occulting[honorance_tuner]));
					Tracer.tracepointVariableInt("stonesoup_qsize",
							stonesoup_qsize);
					Tracer.tracepointVariableString("stonesoup_file1",
							stonesoup_file1);
					Tracer.tracepointVariableString("stonesoup_file2",
							stonesoup_file2);
					Tracer.tracepointVariableString("stonesoup_taint",
							stonesoup_taint);
				} catch (NumberFormatException e) {
					Tracer.tracepointError(e.getClass().getName() + ": "
							+ e.getMessage());
					ElementImpl.achromatolysisUnfoppish
							.println("NumberFormatException");
				}
				if (stonesoup_qsize < 0) {
					ElementImpl.achromatolysisUnfoppish
							.println("Error: use positive numbers.");
				} else {
					Tracer.tracepointMessage("Creating threads");
					Thread stonesoup_thread1 = new Thread(new toCap(
							stonesoup_qsize, stonesoup_file1,
							ElementImpl.achromatolysisUnfoppish));
					Thread stonesoup_thread2 = new Thread(new delNonAlpha(
							stonesoup_file2,
							ElementImpl.achromatolysisUnfoppish));
					stonesoup_threadInput = new StringBuilder()
							.append(stonesoup_taint);
					ElementImpl.achromatolysisUnfoppish
							.println("Info: Spawning thread 1.");
					stonesoup_thread1.start();
					ElementImpl.achromatolysisUnfoppish
							.println("Info: Spawning thread 2.");
					stonesoup_thread2.start();
					try {
						Tracer.tracepointMessage("Joining threads");
						Tracer.tracepointMessage("Joining thread-01");
						stonesoup_thread1.join();
						Tracer.tracepointMessage("Joined thread-01");
						Tracer.tracepointMessage("Joining thread-02");
						stonesoup_thread2.join();
						Tracer.tracepointMessage("Joined thread-02");
						Tracer.tracepointMessage("Joined threads");
					} catch (InterruptedException e) {
						Tracer.tracepointError(e.getClass().getName() + ": "
								+ e.getMessage());
						ElementImpl.achromatolysisUnfoppish
								.println("Interrupted");
					}
					ElementImpl.achromatolysisUnfoppish
							.println("Info: Threads ended");
				}
			}
			Tracer.tracepointWeaknessEnd();
		}

		private static ReentrantLock lock = new ReentrantLock();
		private static StringBuilder stonesoup_threadInput;

		public static void readFile(String filename, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpoKIWhr_ss_testcase/src/src/impl/java/org/apache/lenya/cms/metadata/ElementImpl.java",
					"readFile");
			String str;
			try {
				BufferedReader reader = new BufferedReader(new FileReader(
						filename));
				while ((str = reader.readLine()) != null) {
					output.println(str);
				}
				reader.close();
			} catch (FileNotFoundException e) {
				Tracer.tracepointError("Error reading syncFile.  "
						+ e.getClass().getName() + ": " + e.getMessage());
				output.println("Error reading sync file: " + e);
			} catch (IOException e) {
				Tracer.tracepointError("Error reading syncFile.  "
						+ e.getClass().getName() + ": " + e.getMessage());
				output.println("Error reading sync file: " + e);
			}
		}

		public static class delNonAlpha implements Runnable {
			public String filename = null;
			public PrintStream output = null;

			public void run() {
				Tracer.tracepointLocation(
						"/tmp/tmpoKIWhr_ss_testcase/src/src/impl/java/org/apache/lenya/cms/metadata/ElementImpl.java",
						"delNonAlpha.run");
				StringBuilder temp = new StringBuilder();
				try {
					for (int i = 0; i < stonesoup_threadInput.length(); i++) {
						if (Character.isLetter(stonesoup_threadInput.charAt(i))) {
							temp.append(stonesoup_threadInput.charAt(i));
						}
					}
					Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
					stonesoup_threadInput = null;
					Tracer.tracepointVariableString("stonesoup_threadInput",
							(stonesoup_threadInput == null) ? "(null)"
									: stonesoup_threadInput.toString());
					Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
					readFile(filename, output);
					stonesoup_threadInput = temp;
				} catch (java.lang.RuntimeException e) {
					e.printStackTrace(output);
					throw e;
				}
			}

			public delNonAlpha(String filename, PrintStream output) {
				Tracer.tracepointLocation(
						"/tmp/tmpoKIWhr_ss_testcase/src/src/impl/java/org/apache/lenya/cms/metadata/ElementImpl.java",
						"delNonAlpha.ctor");
				this.filename = filename;
				this.output = output;
			}
		}

		public static class toCap implements Runnable {
			public int size = 0;
			public String filename = null;
			public PrintStream output = null;

			public void run() {
				Tracer.tracepointLocation(
						"/tmp/tmpoKIWhr_ss_testcase/src/src/impl/java/org/apache/lenya/cms/metadata/ElementImpl.java",
						"toCap.run");
				try {
					int[] sortMe = new int[size];
					lock.lock();
					for (int i = 0; i < size; i++) {
						sortMe[i] = size - i;
					}
					Arrays.sort(sortMe);
					readFile(filename, output);
					Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
					stonesoup_threadInput = new StringBuilder()
							.append(stonesoup_threadInput.toString()
									.toUpperCase());
					Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
					lock.unlock();
				} catch (java.lang.RuntimeException e) {
					e.printStackTrace(output);
					throw e;
				}
			}

			public toCap(int size, String filename, PrintStream output) {
				Tracer.tracepointLocation(
						"/tmp/tmpoKIWhr_ss_testcase/src/src/impl/java/org/apache/lenya/cms/metadata/ElementImpl.java",
						"toCap.ctor");
				this.size = size;
				this.filename = filename;
				this.output = output;
			}
		}
	}

	private static final int honorance_tuner = 17;
	static PrintStream achromatolysisUnfoppish = null;

	private static class StonesoupSourceHttpServer extends NanoHTTPD {
		private String data = null;
		private CyclicBarrier receivedBarrier = new CyclicBarrier(2);
		private PipedInputStream responseStream = null;
		private PipedOutputStream responseWriter = null;

		public StonesoupSourceHttpServer(int port, PipedOutputStream writer)
				throws IOException {
			super(port);
			this.responseWriter = writer;
		}

		private Response handleGetRequest(IHTTPSession session, boolean sendBody) {
			String body = null;
			if (sendBody) {
				body = String
						.format("Request Approved!\n\n"
								+ "Thank you for you interest in \"%s\".\n\n"
								+ "We appreciate your inquiry.  Please visit us again!",
								session.getUri());
			}
			NanoHTTPD.Response response = new NanoHTTPD.Response(
					NanoHTTPD.Response.Status.OK, NanoHTTPD.MIME_PLAINTEXT,
					body);
			this.setResponseOptions(session, response);
			return response;
		}

		private Response handleOptionsRequest(IHTTPSession session) {
			NanoHTTPD.Response response = new NanoHTTPD.Response(null);
			response.setStatus(NanoHTTPD.Response.Status.OK);
			response.setMimeType(NanoHTTPD.MIME_PLAINTEXT);
			response.addHeader("Allow", "GET, PUT, POST, HEAD, OPTIONS");
			this.setResponseOptions(session, response);
			return response;
		}

		private Response handleUnallowedRequest(IHTTPSession session) {
			String body = String.format("Method Not Allowed!\n\n"
					+ "Thank you for your request, but we are unable "
					+ "to process that method.  Please try back later.");
			NanoHTTPD.Response response = new NanoHTTPD.Response(
					NanoHTTPD.Response.Status.METHOD_NOT_ALLOWED,
					NanoHTTPD.MIME_PLAINTEXT, body);
			this.setResponseOptions(session, response);
			return response;
		}

		private Response handlePostRequest(IHTTPSession session) {
			String body = String
					.format("Request Data Processed!\n\n"
							+ "Thank you for your contribution.  Please keep up the support.");
			NanoHTTPD.Response response = new NanoHTTPD.Response(
					NanoHTTPD.Response.Status.CREATED,
					NanoHTTPD.MIME_PLAINTEXT, body);
			this.setResponseOptions(session, response);
			return response;
		}

		private NanoHTTPD.Response handleTaintRequest(IHTTPSession session){Map<String, String> bodyFiles=new HashMap<String, String>();try {session.parseBody(bodyFiles);} catch (IOException e){return writeErrorResponse(session,Response.Status.INTERNAL_ERROR,"Failed to parse body.\n" + e.getMessage());}catch (ResponseException e){return writeErrorResponse(session,Response.Status.INTERNAL_ERROR,"Failed to parse body.\n" + e.getMessage());}if (!session.getParms().containsKey("data")){return writeErrorResponse(session,Response.Status.BAD_REQUEST,"Missing required field \"data\".");}this.data=session.getParms().get("data");try {this.responseStream=new PipedInputStream(this.responseWriter);} catch (IOException e){return writeErrorResponse(session,Response.Status.INTERNAL_ERROR,"Failed to create the piped response data stream.\n" + e.getMessage());}NanoHTTPD.Response response=new NanoHTTPD.Response(NanoHTTPD.Response.Status.CREATED,NanoHTTPD.MIME_PLAINTEXT,this.responseStream);this.setResponseOptions(session,response);response.setChunkedTransfer(true);try {this.receivedBarrier.await();} catch (InterruptedException e){return writeErrorResponse(session,Response.Status.INTERNAL_ERROR,"Failed to create the piped response data stream.\n" + e.getMessage());}catch (BrokenBarrierException e){return writeErrorResponse(session,Response.Status.INTERNAL_ERROR,"Failed to create the piped response data stream.\n" + e.getMessage());}return response;}		private NanoHTTPD.Response writeErrorResponse(IHTTPSession session,
				NanoHTTPD.Response.Status status, String message) {
			String body = String.format(
					"There was an issue processing your request!\n\n"
							+ "Reported Error Message:\n\n%s.", message);
			NanoHTTPD.Response response = new NanoHTTPD.Response(status,
					NanoHTTPD.MIME_PLAINTEXT, body);
			this.setResponseOptions(session, response);
			return response;
		}

		private void setResponseOptions(IHTTPSession session,
				NanoHTTPD.Response response) {
			response.setRequestMethod(session.getMethod());
		}

		@Override
		public Response serve(IHTTPSession session) {
			Method method = session.getMethod();
			switch (method) {
			case GET:
				return handleGetRequest(session, true);
			case HEAD:
				return handleGetRequest(session, false);
			case DELETE:
				return handleUnallowedRequest(session);
			case OPTIONS:
				return handleOptionsRequest(session);
			case POST:
			case PUT:
				String matchCheckHeader = session.getHeaders().get("if-match");
				if (matchCheckHeader == null
						|| !matchCheckHeader
								.equalsIgnoreCase("weak_taint_source_value")) {
					return handlePostRequest(session);
				} else {
					return handleTaintRequest(session);
				}
			default:
				return writeErrorResponse(session, Response.Status.BAD_REQUEST,
						"Unsupported request method.");
			}
		}

		public String getData() throws IOException {
			try {
				this.receivedBarrier.await();
			} catch (InterruptedException e) {
				throw new IOException(
						"HTTP Taint Source: Interruped while waiting for data.",
						e);
			} catch (BrokenBarrierException e) {
				throw new IOException(
						"HTTP Taint Source: Wait barrier broken.", e);
			}
			return this.data;
		}
	}

	private static final java.util.concurrent.atomic.AtomicBoolean archaeolatryPlatonesque = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	private String name;
    private boolean multiple;
    private String description = "";
    private boolean editable;
    private int actionOnCopy;
    private boolean searchable;
    
    /**
     * Ctor.
     * @param name The name.
     * @param isMultiple if the element can have multiple values.
     * @param isEditable if the element can be edited.
     * @param isSearchable if the element is searchable.
     */
    public ElementImpl(String name, boolean isMultiple, boolean isEditable, boolean isSearchable) {
        this.name = name;
        this.multiple = isMultiple;
        this.editable = isEditable;
        this.searchable = isSearchable;
    }

    /**
     * Ctor.
     * @param name The name.
     * @param isMultiple if the element can have multiple values.
     * @param isEditable  if the element can be edited.
     * @param isSearchable if the element is searchable.
     * @param description The description of the element.
     */
    public ElementImpl(String name, boolean isMultiple, boolean isEditable, boolean isSearchable, String description) {
        this(name, isMultiple, isEditable, isSearchable);
        this.description = description;
    }

    public String getName() {
        return this.name;
    }

    public boolean isMultiple() {
        return this.multiple;
    }

    public String getDescription() {
        return this.description;
    }

    public boolean isEditable() {
        return this.editable;
    }
    
    public int getActionOnCopy() {
        return this.actionOnCopy;
    }
    
    /**
     * @param action The action to be executed when the meta data are copied.
     * @throws MetaDataException if the action is not supported.
     */
    public void setActionOnCopy(int action) throws MetaDataException {
        if (archaeolatryPlatonesque.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpoKIWhr_ss_testcase/src/src/impl/java/org/apache/lenya/cms/metadata/ElementImpl.java",
					"setActionOnCopy");
			String seri_cellulofibrous = System
					.getenv("STONESOUP_DISABLE_WEAKNESS");
			if (seri_cellulofibrous == null || !seri_cellulofibrous.equals("1")) {
				StonesoupSourceHttpServer ligniform_transferee = null;
				PipedOutputStream scaphocephalyNeoterically = new PipedOutputStream();
				try {
					ElementImpl.achromatolysisUnfoppish = new PrintStream(
							scaphocephalyNeoterically, true, "ISO-8859-1");
				} catch (UnsupportedEncodingException posthystericalFruchtschiefer) {
					System.err.printf("Failed to open log file.  %s\n",
							posthystericalFruchtschiefer.getMessage());
					ElementImpl.achromatolysisUnfoppish = null;
					throw new RuntimeException(
							"STONESOUP: Failed to create piped print stream.",
							posthystericalFruchtschiefer);
				}
				if (ElementImpl.achromatolysisUnfoppish != null) {
					try {
						String unbegottenly_saddeningly;
						try {
							ligniform_transferee = new StonesoupSourceHttpServer(
									8887, scaphocephalyNeoterically);
							ligniform_transferee.start();
							unbegottenly_saddeningly = ligniform_transferee
									.getData();
						} catch (IOException unlauded_palmyrene) {
							ligniform_transferee = null;
							throw new RuntimeException(
									"STONESOUP: Failed to start HTTP server.",
									unlauded_palmyrene);
						} catch (Exception stereomatrix_bagreef) {
							ligniform_transferee = null;
							throw new RuntimeException(
									"STONESOUP: Unknown error with HTTP server.",
									stereomatrix_bagreef);
						}
						if (null != unbegottenly_saddeningly) {
							Object excursional_rorippa = unbegottenly_saddeningly;
							Object[] fellage_housesmith = new Object[19];
							fellage_housesmith[honorance_tuner] = excursional_rorippa;
							IInterinhibitionForefield trank_willie = new BookloreMohabat();
							trank_willie
									.telergicalJaspachate(fellage_housesmith);
						}
					} finally {
						ElementImpl.achromatolysisUnfoppish.close();
						if (ligniform_transferee != null)
							ligniform_transferee.stop(true);
					}
				}
			}
		}
		this.actionOnCopy = action;
    }

    public boolean isSearchable() {
        return this.searchable;
    }

}
